<template>
	<div class="left__top--five wow fadeInUp">
		<svg class="five-absolute">
			<use xlink:href="/img/sprite.svg#cycle-loading"/>
		</svg>
		<p class="five-title">{{ $t('dashboard.events.title') }}</p>
		<p class="five-podTitle">{{ $t('dashboard.events.sub_title') }} </p>
		<div class="five__link--flex">
			<a href="#" class="five__link--element"
			   @click.prevent="setFilter('refills')">{{ $t('dashboard.events.operations.refills') }}</a>
			<a href="#" class="five__link--element"
			   @click.prevent="setFilter('withdraws')">{{ $t('dashboard.events.operations.withdraws') }}</a>
			<a href="#" class="five__link--element"
			   @click.prevent="setFilter('deposits')">{{ $t('dashboard.events.operations.deposits') }}</a>
			<a href="#" class="five__link--element"
			   @click.prevent="setFilter('registrations')">{{ $t('dashboard.events.operations.registrations') }}</a>
			<a href="#" class="five__link--element"
			   @click.prevent="setFilter('ref_pays')">{{ $t('dashboard.events.operations.ref_pays') }}</a>
		</div>
		<div class="five__btn--flex">
			<a href="#" class="btn--element" v-if="hasRefillFilter" @click.prevent="removeFilter('refills')">
				<svg>
					<use xlink:href="/img/sprite.svg#cancel-button"/>
				</svg>
				{{ $t('dashboard.events.operations.refills') }}
			</a>
			<a href="#" class="btn--element" v-if="hasWithdrawsFilter" @click.prevent="removeFilter('withdraws')">
				<svg>
					<use xlink:href="/img/sprite.svg#cancel-button"/>
				</svg>
				{{ $t('dashboard.events.operations.withdraws') }}
			</a>
			<a href="#" class="btn--element" v-if="hasDepositsFilter" @click.prevent="removeFilter('deposits')">
				<svg>
					<use xlink:href="/img/sprite.svg#cancel-button"/>
				</svg>
				{{ $t('dashboard.events.operations.deposits') }}
			</a>
			<a href="#" class="btn--element" v-if="hasRegistrationsFilter"
			   @click.prevent="removeFilter('registrations')">
				<svg>
					<use xlink:href="/img/sprite.svg#cancel-button"/>
				</svg>
				{{ $t('dashboard.events.operations.registrations') }}
			</a>
			<a href="#" class="btn--element" v-if="hasRefPaysFilter" @click.prevent="removeFilter('ref_pays')">
				<svg>
					<use xlink:href="/img/sprite.svg#cancel-button"/>
				</svg>
				{{ $t('dashboard.events.operations.ref_pays') }}
			</a>
		</div>
		<div class="box-events">

			<div class="box__table--element elementNone" v-for="event in filtered">
				<div class="green__element">
					<div class="element__right">
						<div class="green__svg" :class="svgColor(event)">
							<svg>
								<use :xlink:href="svgIcon(event)"/>
							</svg>
						</div>
						<p class="text-bold">{{ type(event) }} <span class="date">{{ formatDate(event) }}</span></p>
					</div>
					<p class="summa" :class="sumColor(event)">{{ sum(event) }}</p>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import _ from 'lodash';

export default {
	name: "LastEventsBlock",
	props: ['events'],
	data() {
		return {
			filters: [],
		};
	},
	computed: {
		hasRefillFilter() {
			return _.indexOf(this.filters, 'refills') !== -1;
		},
		hasWithdrawsFilter() {
			return _.indexOf(this.filters, 'withdraws') !== -1;
		},
		hasDepositsFilter() {
			return _.indexOf(this.filters, 'deposits') !== -1;
		},
		hasRegistrationsFilter() {
			return _.indexOf(this.filters, 'registrations') !== -1;
		},
		hasRefPaysFilter() {
			return _.indexOf(this.filters, 'ref_pays') !== -1;
		},
		filtered() {
			let events = [];
			if (this.filters.length) {
				events = _.filter(this.events, event => {
					return _.indexOf(this.filters, event.event_type) !== -1;
				});
			} else {
				events = this.events;
			}
			return _.slice(events, 0, 10);
		}
	},
	methods: {
		setFilter(filter) {
			if (_.indexOf(this.filters, filter) === -1) {
				this.filters.push(filter);
			}
		},
		removeFilter(filter) {
			let i = _.indexOf(this.filters, filter);
			if (i !== -1) {
				this.filters.splice(i, 1);
			}
		},
		hasFilter(filter) {
			return _.indexOf(this.filters, filter) !== -1;
		},
		getType(event) {
			if (event.type && event.type === 'user_refill') {
				return 'refills';
			} else if (event.type && event.type === 'user_withdraw') {
				return 'withdraws';
			} else if (event.type && event.type === 'referral_pay') {
				return 'ref_pays';
			} else if (event.passed_accruals) {
				return 'deposits';
			} else if (event.login) {
				return 'registrations';
			}
		},
		svgColor(event) {
			if (event.event_type === 'withdraws') {
				return {
					'red__svg': true,
					'rotate-90': true,
				};
			} else if (event.event_type === 'deposits' || event.event_type === 'ref_pays') {
				return {
					'blue__svg': true
				};
			} else if (event.event_type === 'registrations') {
				return {
					'gray__svg': true
				};
			}
		},
		svgIcon(event) {
			if (event.event_type === 'refills' || event.event_type === 'ref_pays') {
				return '/img/sprite.svg#coins-1';
			} else if (event.event_type === 'withdraws') {
				return '/img/sprite.svg#level-up';
			} else if (event.event_type === 'deposits') {
				return '/img/sprite.svg#portfolio-of-business';
			} else if (event.event_type === 'registrations') {
				return '/img/sprite.svg#profile';
			}
		},
		type(event) {
			if (event.event_type === 'refills') {
				return this.$t('dashboard.events.operations.refill');
			} else if (event.event_type === 'withdraws') {
				return this.$t('dashboard.events.operations.withdraw');
			} else if (event.event_type === 'deposits') {
				return this.$t('dashboard.events.operations.deposit');
			} else if (event.event_type === 'registrations') {
				return this.$t('dashboard.events.operations.registration');
			} else if (event.event_type === 'ref_pays') {
				return this.$t('dashboard.events.operations.ref_pay');
			}
		},
		formatDate(event) {
			return this.$date(event.created_at).format('DD.MM.YYYY HH:mm');
		},
		sumColor(event) {
			if (event.event_type === 'withdraws') {
				return {
					red: true
				};
			} else if (event.event_type === 'deposits') {
				return {
					blue: true
				};
			} else if (event.event_type === 'registrations') {
				return {
					gray: true
				};
			}
		},
		sum(event) {
			if (event.event_type === 'refills') {
				return '+ $ ' + Number.parseFloat(event.amount).toFixed(2);
			} else if (event.event_type === 'withdraws') {
				return '- $ ' + Number.parseFloat(event.amount).toFixed(2);
			} else if (event.event_type === 'deposits') {
				return '$ ' + Number.parseFloat(event.amount).toFixed(2);
			} else if (event.event_type === 'registrations') {
				return event.login;
			} else if (event.event_type === 'ref_pays') {
				return '+ $ ' + Number.parseFloat(event.amount).toFixed(2);
			}
		},
	}

}
</script>

<style scoped lang="scss">
.box-events {
	max-height: 740px;
	overflow-y: scroll;
	padding: 10px;
}

.rotate-90 {
	transform: rotate(90deg);
}
.left__top--five .box__table--element {

	padding: 0 28px 0 32px;
	.green__element .element__right .gray__svg{
		background-color: #ececec;
		background-image: none;

		svg{
			fill: #a8a8a8;
		}
	}
}
</style>
